xref: /petsc/config/petsc_harness.sh (revision 8fb2ab26d80daab5aa3994b1ab9f0a6625b167ee)
1
2
3scriptname=`basename $0`
4rundir=${scriptname%.sh}
5TIMEOUT=60
6
7if test "$PWD"!=`dirname $0`; then
8  cd `dirname $0`
9fi
10if test -d "${rundir}" && test -n "${rundir}"; then
11  rm -f ${rundir}/*.tmp ${rundir}/*.err ${rundir}/*.out
12fi
13mkdir -p ${rundir}
14if test -n "${runfiles}"; then
15  for runfile in ${runfiles}; do
16      subdir=`dirname ${runfile}`
17      mkdir -p ${rundir}/${subdir}
18      cp -r ${runfile} ${rundir}/${subdir}
19  done
20fi
21cd ${rundir}
22
23#
24# Method to print out general and script specific options
25#
26print_usage() {
27
28cat >&2 <<EOF
29Usage: $0 [options]
30
31OPTIONS
32  -a <args> ......... Override default arguments
33  -c <cleanup> ...... Cleanup (remove generated files)
34  -d ................ Launch in debugger
35  -e <args> ......... Add extra arguments to default
36  -f ................ force attempt to run test that would otherwise be skipped
37  -h ................ help: print this message
38  -n <integer> ...... Override the number of processors to use
39  -j ................ Pass -j to petscdiff (just use diff)
40  -J <arg> .......... Pass -J to petscdiff (just use diff with arg)
41  -m ................ Update results using petscdiff
42  -M ................ Update alt files using petscdiff
43  -t ................ Override the default timeout (default=$TIMEOUT sec)
44  -V ................ run Valgrind
45  -v ................ Verbose: Print commands
46EOF
47
48  if declare -f extrausage > /dev/null; then extrausage; fi
49  exit $1
50}
51###
52##  Arguments for overriding things
53#
54verbose=false
55cleanup=false
56debugger=false
57force=false
58diff_flags=""
59while getopts "a:cde:fhjJ:mMn:t:vV" arg
60do
61  case $arg in
62    a ) args="$OPTARG"       ;;
63    c ) cleanup=true         ;;
64    d ) debugger=true        ;;
65    e ) extra_args="$OPTARG" ;;
66    f ) force=true           ;;
67    h ) print_usage; exit    ;;
68    n ) nsize="$OPTARG"      ;;
69    j ) diff_flags="-j"      ;;
70    J ) diff_flags="-J $OPTARG" ;;
71    m ) diff_flags="-m"      ;;
72    M ) diff_flags="-M"      ;;
73    t ) TIMEOUT=$OPTARG      ;;
74    V ) mpiexec="petsc_mpiexec_valgrind $mpiexec" ;;
75    v ) verbose=true         ;;
76    *)  # To take care of any extra args
77      if test -n "$OPTARG"; then
78        eval $arg=\"$OPTARG\"
79      else
80        eval $arg=found
81      fi
82      ;;
83  esac
84done
85shift $(( $OPTIND - 1 ))
86
87# Individual tests can extend the default
88export MPIEXEC_TIMEOUT=$((TIMEOUT*timeoutfactor))
89STARTTIME=`date +%s`
90
91if test -n "$extra_args"; then
92  args="$args $extra_args"
93fi
94if $debugger; then
95  args="-start_in_debugger $args"
96fi
97
98
99# Init
100success=0; failed=0; failures=""; rmfiles=""
101total=0
102todo=-1; skip=-1
103job_level=0
104
105function petsc_testrun() {
106  # First arg = Basic command
107  # Second arg = stdout file
108  # Third arg = stderr file
109  # Fourth arg = label for reporting
110  # Fifth arg = Filter
111  rmfiles="${rmfiles} $2 $3"
112  tlabel=$4
113  filter=$5
114  cmd="$1 > $2 2> $3"
115  if test -n "$filter"; then
116    if test "${filter:0:6}"=="Error:"; then
117      filter=${filter##Error:}
118      cmd="$1 2>&1 | cat > $2"
119    fi
120  fi
121  echo "$cmd" > ${tlabel}.sh; chmod 755 ${tlabel}.sh
122
123  #eval "time $cmd"
124  eval "{ time -p $cmd ; } 2> timing.out"
125  cmd_res=$?
126  timing=`grep real timing.out  | cut -f2 -d' '`
127  # ETIMEDOUT=110 on most systems (used by Open MPI 3.0).  MPICH uses
128  # 255.  Earlier Open MPI returns 1 but outputs about MPIEXEC_TIMEOUT.
129  if [ $cmd_res -eq 110 -o $cmd_res -eq 255 ] || \
130        fgrep -q -s 'APPLICATION TIMED OUT' "$2" "$3" || \
131        fgrep -q -s MPIEXEC_TIMEOUT "$2" "$3" || \
132        fgrep -q -s 'APPLICATION TERMINATED WITH THE EXIT STRING: job ending due to timeout' "$2" "$3" || \
133        grep -q -s "Timeout after [0-9]* seconds. Terminating job" "$2" "$3"; then
134    timed_out=1
135    # If timed out, then ensure non-zero error code
136    if [ $cmd_res -eq 0 ]; then
137      cmd_res=1
138    fi
139  fi
140
141  # Handle filters separately and assume no timeout check needed
142  if test -n "$filter"; then
143    cmd="cat $2 | $filter > $2.tmp 2>> $3 && mv $2.tmp $2"
144    echo "$cmd" >> ${tlabel}.sh
145    eval "$cmd"
146  fi
147
148  # Report errors
149  if test $cmd_res == 0; then
150    if "${verbose}"; then
151     printf "ok $tlabel $cmd\n" | tee -a ${testlogfile}
152    else
153     printf "ok $tlabel\n" | tee -a ${testlogfile}
154    fi
155    let success=$success+1
156  else
157    if "${verbose}"; then
158      printf "not ok $tlabel $cmd\n" | tee -a ${testlogfile}
159    else
160      printf "not ok $tlabel\n" | tee -a ${testlogfile}
161    fi
162    if [ -v timed_out ]; then
163      printf "#\tExceeded timeout limit of $MPIEXEC_TIMEOUT s\n" | tee -a ${testlogfile}
164    else
165      # We've had tests fail but stderr->stdout. Fix with this test.
166      if test -s $3; then
167        awk '{print "#\t" $0}' < $3 | tee -a ${testlogfile}
168      else
169        awk '{print "#\t" $0}' < $2 | tee -a ${testlogfile}
170      fi
171    fi
172    let failed=$failed+1
173    failures="$failures $tlabel"
174  fi
175  let total=$success+$failed
176  return $cmd_res
177}
178
179function petsc_testend() {
180  logfile=$1/counts/${label}.counts
181  logdir=`dirname $logfile`
182  if ! test -d "$logdir"; then
183    mkdir -p $logdir
184  fi
185  if ! test -e "$logfile"; then
186    touch $logfile
187  fi
188  printf "total $total\n" > $logfile
189  printf "success $success\n" >> $logfile
190  printf "failed $failed\n" >> $logfile
191  printf "failures $failures\n" >> $logfile
192  if test ${todo} -gt 0; then
193    printf "todo $todo\n" >> $logfile
194  fi
195  if test ${skip} -gt 0; then
196    printf "skip $skip\n" >> $logfile
197  fi
198  ENDTIME=`date +%s`
199  #printf "time $(($ENDTIME - $STARTTIME))\n" >> $logfile
200  printf "time $timing\n" >> $logfile
201  if $cleanup; then
202    echo "Cleaning up"
203    /bin/rm -f $rmfiles
204  fi
205}
206
207function petsc_mpiexec_valgrind() {
208  mpiexec=$1;shift
209  npopt=$1;shift
210  np=$1;shift
211
212  valgrind="valgrind -q --tool=memcheck --leak-check=yes --num-callers=20 --track-origins=yes --suppressions=$petsc_bindir/maint/petsc-val.supp"
213
214  $mpiexec $npopt $np $valgrind $*
215}
216export LC_ALL=C
217